//常量区
let UserSetting = ice.localData('UserConfig');
ice.localData('UserConfig',AppDefinedOptions);
UserSetting = AppDefinedOptions;
const unClick = UserSetting.unclickColor;
const Clicked = UserSetting.clickedColor;

/* 
 * @name(返回一个时间提示词)
 * @custom(void)
 * @ret(String)
 */
function getDateChar(){
  const WordArray = [
    '凌晨的黑暗总是孤单的',
    '早上好呀',
    '上午的阳光总是格外明朗',
    '中午是一天的1/3',
    '陪伴是下午的片刻安定',
    '晚上的时光总是静谧而安静',
    '夜深了'
  ];
  const Hours = new Date().getHours();
  if(Hours >= 0 && Hours < 6) return WordArray[0];  
  if(Hours >= 6 && Hours < 8) return WordArray[1];  
  if(Hours >= 8 && Hours < 12) return WordArray[2];  
  if(Hours >= 12 && Hours < 15) return WordArray[3];  
  if(Hours >= 15 && Hours < 19) return WordArray[4];  
  if(Hours >= 19 && Hours < 21) return WordArray[5];  
  if(Hours >= 21 && Hours <= 24) return WordArray[6];  
}
/* 
 * @name(获取min至max的随机整数)
 * @custom(int min,int max)
 * @ret(int)
 */
function getRandNumOf(min, max){
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min + 1)) + min;
}
/* 
 * @name(依据导航栏切换页面)
 * @custom(HtmlColl NavElements,int oldNavId,int targetNavId...)
 * @ret(void)
 */
function togglePageOfNav(NavElements,oldNavId,targetNavId,NavIcons,swip){
  const oldElement = NavElements.item(oldNavId);
  const targetElement = NavElements.item(targetNavId);
  oldElement.querySelector('img').src = NavIcons.unclicks[oldNavId];
  targetElement.querySelector('img').src = NavIcons.clicked[targetNavId];
  oldElement.querySelector('p').style.color = unClick;
  targetElement.querySelector('p').style.color = Clicked;
  swip.slideTo(targetNavId,100,false);
}
/* 
 * @name(仅切换导航栏)
 * @custom()
 * @ret(void)
 */
function changeNav(NavElements,oldNavId,targetNavId,NavIcons){
  const oldElement = NavElements.item(oldNavId);
  const targetElement = NavElements.item(targetNavId);
  oldElement.querySelector('img').src = NavIcons.unclicks[oldNavId];
  targetElement.querySelector('img').src = NavIcons.clicked[targetNavId];
  oldElement.querySelector('p').style.color = unClick;
  targetElement.querySelector('p').style.color = Clicked;
}
/* 
 * @name('快捷提示')
 * @custom(void)
 * @ret(void)
 */
function showWarning(text) {
  ice.pop({
    content: text,
    icon: 'warning',
    time: 1500,
  });
}

function showSuccess(text) {
  ice.pop({
    content: text,
    icon: 'success',
    time: 1500
  });
}
/* 
 * @name(用于抽象的控制切换)
 * @custom(int oldId,int newId,NodeList Navs | Areas,...)
 * @ret(void)
 */
function toggleCont(oldId,newId,Navt,Areat,Icons){
  let oldNavElem = Navt[oldId];
  let newNavElem = Navt[newId];
  let oldAreaElem = Areat.querySelector(UserSetting.BindCss[oldId]);
  let newAreaElem = Areat.querySelector(UserSetting.BindCss[newId]);
  oldNavElem.querySelector('img').src = Icons[oldId][0];
  newNavElem.querySelector('img').src = Icons[newId][1];
  oldAreaElem.style.display = 'none';
  newAreaElem.style.display = 'block';
}
/* 
 * @name('获取随机数')
 * @custom(int min,int max)
 * @ret(int)
 */
function getRandom(min, max) {
  let choices = max - min;
  return Math.floor(Math.random() * choices + min);
}
/* 
 * @name(从一个数组里随机抽取值)
 * @custom(int num)
 * @ret(Array)
 */
function randomSample(arr) {
  for (let i = arr.length - 1; i > 0; i--) {
    const j = Math.floor(Math.random() * (i + 1));
    [arr[i], arr[j]] = [arr[j], arr[i]];
  }
  return arr;
}
/* 
 * @name(获取所需信息)
 * @custom(int id)
 * @ret(object)
 */
function requestMusicInfo(mid,fork,sunm) {
  return fetch(`https://kw-api.cenguigui.cn?id=${mid}&type=song&level=exhigh&format=json`)
    .then((response) => response.json())
    .then((data) => {
      if(!data.code == 200) return null;
      data = data.data;
      if(!data.name){
        return false;
      }
      let ends = {
        musName : data.name,
        musAuth : data.artist,
        musPic : data.pic,
        musUrl : data.url,
        musId : mid,
        musSu : sunm
      };
      return ends;
    })
    .catch((e) => alert(e));
} 
/* 
 * @name(获取搜索列表)
 * @custom(string str)
 * @ret(void)
 */
function reqSearch(text){
  SearColl.innerHTML = '';
    let loadPop = layui.layer.open({
      type : 3,
      content : 'Searching...',
      title : false,
      icon : 1,
      shade : 0.5
    });
    fetch(`https://kw-api.cenguigui.cn?name=${text}&page=1&limit=50`)
      .then((response) => response.json())
      .then((data) => {
        if(data.code != 200) {
          layui.layer.close(loadPop);
          mui.alert('未搜索到歌曲','提示','好的');
          wagSwip.enable();
        };
        let targets = data.data;
        let endObj = [];
        let sunm = 0;
        layui.layer.close(loadPop);
        for(let target of targets){
          endObj.push({
            musName: target.name,
            musAuth: target.artist,
            musPic: target.pic,
            musUrl: target.url,
            musId: target.rid,
            musSu: sunm
          });
          sunm++;
        }
        for(let i = 0;i < endObj.length;i++){
          let musInfo = endObj[i];
          ice('.sc-coll').append(`
            <div class="mus-sear" data-mlid='${musInfo.musSu}'>
              <div class="ms-img" data-mid='${musInfo.musSu}'>
                <img src="${musInfo.musPic}"/>
              </div>
              <div class="ms-musContet" data-mid='${musInfo.musSu}'>
                <h1>${musInfo.musName}</h1>
                <p>${musInfo.musAuth}</p>
              </div>
            </div>
          `);
        }
        tmpMusicList = endObj;
      })
      .catch((e) => console.log(e));
}
/* 
 * @name(用于提炼网易云歌曲)
 * @custom(Array target)
 * @ret(Array)
 */
function parseNetEasy(target,parseNum){
  let retArr = new Array();
  let inm = 0;
  for(let i = 0;i < target.length;i++){
    if(i >= parseNum) break;
    let val = target[i];
    retArr.push(requestMusicInfo(val.id,inm));
    inm++;
  }
  return retArr;
}
/* 
 * @name(解析网易云歌单)
 * @custom(int lid)
 * @ret(Array)
 */
function requestListInfo(lid) {
  return fetch(`https://kw-api.cenguigui.cn?id=${lid}&type=list`)
    .then((response) => response.json())
    .then((data) => {
      let sunm = 0;
      if (data.code != 200) {
        return null;
      }
      let retArray = [];
      let musList = data.data.musicList;
      console.log(data);
      let endf = {
        musicListInfo : {
          mlName : data.name,
          mlInfo : data.desc,
          mlPic : data.img300
        },
        musics : null
      };
      for(let val of musList){
        retArray.push({
          musName : val.name,
          musAuth : val.artist,
          musPic : val.pic,
          musUrl : val.url,
          musId : val.rid,
          musSu : sunm
        });
        sunm++;
      }
      endf.musics = retArray;
      console.log(endf);
      return endf;
    })
    .catch((e) => console.log(e));
}
/* 
 * @name(随机获取3个歌单)
 * @custom(int n)
 * @ret(lid)
 */
function getMusicListId(n) {
  let num = getRandNumOf(1,3);
  return fetch(`https://kw-api.cenguigui.cn?name=最新&page=${num}&type=rcmlist`)
    .then((response) => response.json())
    .then((data) => {
      console.log(data);
      let endl = data.data.musicList;
      endl = randomSample(endl);
      let resover = [];
      for(let i = 0;i < n;i++){
        let inie = getRandNumOf(0,endl.length - 1);
        if(!endl[inie]) {
          n++;
          continue;
        }
        let lid = Number.parseInt(endl[inie].rid);
        endl[inie] = null;
        resover.push(lid);
      }
      return resover;
    })
    .catch((e) => console.log(e))
}
/* 
 * @name(请求榜单)
 * @custom(int swit)
 * @ret(void)
 */
async function reqmus(swit){
  let retArr = new Array();
  let muslist = [
    '.hot-list',
    '.new-list',
    '.up-list'
  ];
  let musId = await getMusicListId(3);
  let request = await requestListInfo(musId[swit]);
  let musData = request.musics;
  retArr = musData;
  musData = randomSample(musData);
  document.querySelector(muslist[swit]).innerHTML = '';
  for(let i = 0;i < UserSetting.netEasyMus;i++){
    let musInfo = musData[i];
    ice(muslist[swit]).append(`
      <div class="mus-top-c1" data-murl='${musInfo.musUrl}' data-mlid='${musInfo.musSu}' data-lid='${swit}'>
        <div class="headImg">
          <img data-musid='${musInfo.musId}' src="${musInfo.musPic}"/>
        </div>
        <div class="musContet">
          <h1>${musInfo.musName}</h1>
          <p>${musInfo.musAuth}</p>
        </div>
        <div class="musCt">
          <img src="images/app/musMore.svg"/>
        </div>
      </div>
    `);
  }
  return retArr;
}
/* 
 * @name(随机切换榜单内展示的歌曲)
 * @custom(int lid,Array arr)
 * @ret(void)
 */
function chengList(lid,arr){
  let muslist = [
    '.hot-list',
    '.new-list',
    '.up-list'
  ];
  document.querySelector(muslist[lid]).innerHTML = '';
  arr = randomSample(arr);
  for (let i = 0; i < UserSetting.netEasyMus; i++) {
    let data = arr[i];
    ice(muslist[lid]).append(`
      <div class="mus-top-c1" data-murl='${data.musUrl}' data-mlid='${data.musSu}' data-lid='${lid}'>
        <div class="headImg">
          <img data-musid='${data.musId}' src="${data.musPic}"/>
        </div>
        <div class="musContet">
          <h1>${data.musName}</h1>
           <p>${data.musAuth}</p>
         </div>
        <div class="musCt">
          <img src="images/app/musMore.svg"/>
        </div>
      </div>
    `);
  }
}
/* 
 * @name(歌曲载入)
 * @custom(object inits,bool needFull)
 * @ret(void)
 */
function musInited(musOption,needFull=false){
  let targetObject = musOption;
  tempMObj = targetObject;
  musplayImg.style.backgroundImage = 'url(' + targetObject.musPic + ')';
  musplayText.textContent = targetObject.musName;
  audioElem.src = targetObject.musUrl;
  audioElem.play();
  musplayCont.src = 'images/app/stop.svg';
  musplayImg.style.animationPlayState = 'running';
  LPTitle.textContent = targetObject.musName;
  LPInfo.textContent = targetObject.musAuth;
  LPImage.src = targetObject.musPic;
  SPCorl.src = 'images/app/startPlay.svg';
  mpSlid.setValue(0);
  if(needFull){
    wagSwip.slideTo(2);
    LPImage.style.animationPlayState = 'running';
  }
}
/* 
 * @name(对未知音乐继续解析播放)
 * @custom(object musOption)
 * @ret(void)
 */
function musCle(musOption){
  let targetObject = musOption;
  tempMObj = targetObject;
  musplayImg.style.backgroundImage = 'url(' + targetObject.musPic + ')';
  LPImage.src = targetObject.musPic;
  musplayText.textContent = targetObject.musName;
  audioElem.src = targetObject.musUrl;
  audioElem.play();
  musplayCont.src = 'images/app/stop.svg';
  musplayImg.style.animationPlayState = 'running';
  LPImage.style.animationPlayState = 'running';
  LPTitle.textContent = targetObject.musName;
  LPInfo.textContent = targetObject.musAuth;
  SPCorl.src = 'images/app/startPlay.svg';
  mpSlid.setValue(0);
}
/* 
 * @name(仅执行一次的初始化函数)
 * @custom(func func)
 * @ret(void)
 */
function gloabInit(func) {
  let isInited = ice.localData('INITED');
  if(!isInited){
    func();
    ice.localData('INITED',true);
  }
}
/* 
 * @name(添加歌单)
 * @custom(string mlName,string mlInfo)
 * @ret(void)
 */
function codeInML(mlName,mlInfo) {
  let mlid = ice.localData('mlid');
  mlid = Number.parseInt(mlid);
  let mlObject = {
    mlName : mlName,
    mlInfo : mlInfo,
    mlUrl : 'images/core/unMusiList.png',
    mlId : mlid,
    songs : []
  };
  mlid++;
  mlid = '' + mlid;
  ice.localData('mlid',mlid);
  ice('.inf-coll').append(`
    <div class="ifc-lick">
      <div class="il-img" data-ilter="${mlid}">
        <img src="images/core/unMusicList.png"/>
      </div>
      <div class="il-cone" data-ilter="${mlid}">
        <span>${mlInfo}</span>
        <p>${mlName}</p>
      </div>
    </div>
  `);
  let temp = ice.localData('musiclist');
  temp.push(mlObject);
  ice.localData('musiclist',temp);
}
/* 
 * @name(解析歌单以展示添加用)
 * @custom(void)
 * @ret(String)
 */
function parseMLof() {
  let mls = ice.localData('musiclist');
  let tmp = '';
  mls.forEach((value,index,array) => {
    tmp += `
      <div class="ifc-lick">
        <div class="il-img" data-ilter="${value.mlId}">
          <img src="images/core/unMusicList.png"/>
        </div>
        <div class="il-cone" data-ilter="${value.mlId}">
          <span>${value.mlInfo}</span>
          <p>${value.mlName}</p>
        </div>
      </div>
    `;
  });
  return tmp;
}
/* 
 * @name(依据mlid筛选出需要的歌单数据)
 * @custom(int mlid)
 * @ret(Object)
 */
function selectML(mlid) {
  let mls = ice.localData('musiclist');
  let ended = null;
  mls.forEach((value,index,array) => {
    if(value.mlId != mlid) return;
    ended = value;
  });
  return ended;
}